#include <iostream> 
#include <string> 
using namespace std; 
 
class Shape { 
  // private 
  double width; 
  double height; 
public: 
  Shape(double w, double h) { 
    width = w; 
    height = h; 
  } 
 
  void display() { 
    cout << "Width and height are " << width << " and " << height << "\n"; 
  } 
 
  double getWidth() { return width; } 
  double getHeight() { return height; } 
  void setWidth(double w) { width = w; } 
  void setHeight(double h) { height = h; } 
}; 
 
class Triangle : public Shape { // public Vererbung
  string style; // now private 
public: 
  Triangle(const string &str1, double w, double h) : Shape(w, h) { 
    style = str1;
  } 
   
  double area() { 
    return getWidth() * getHeight() / 2; 
  } 
 
  void showStyle() { 
    cout << "Triangle is " << style << "\n"; 
  } 
}; 
 
int main() { 
  Triangle t1("isosceles", 4.0, 4.0); 
  Triangle t2("right", 8.0, 12.0); 
 
  cout << "Info for t1:\n"; 
  t1.showStyle(); 
  t1.display(); 
  cout << "Area is " << t1.area() << "\n"; 
 
  t2.showStyle(); 
  t2.display(); 
  cout << "Area is " << t2.area() << "\n"; 
  cin.get();
  return 0; 
}